// tfam_mouse.c

#include "config.h"

// B2: LED

static U16 clock;
static U8 intensity;
static bit increasing;

void rollover() {
    if (increasing) {
        if (intensity >= 10) {
            increasing = FALSE;
        } else {
            intensity++;
        }
    } else {
        if (intensity <= 0) {
            increasing = TRUE;
        } else {
            intensity--;
        }
    }
}

void tfam_led_init() {
    // set LED pin to output
    DDRB |= 0x04;
    PORTB &= ~0x04;
    clock = 0;
    intensity = 0;
    increasing = TRUE;
}

void tfam_led_light() {
    intensity = 20;
    increasing = FALSE;
}

void tfam_led_tick() {
    U8 fract;
    
    clock++;
    if (clock == 200) {
        clock = 0;
        rollover();
    }
    fract = clock % 20;
    if (intensity > fract) {
        PORTB |= 0x04;
    } else {
        PORTB &= ~0x04;
    }
}
